//=============================================================================
// IClientWindow.
//=============================================================================
class IClientWindow extends UWindowDialogClientWindow;

var UWindowLabelControl Label;
var UWindowCheckbox bHardCoreFrags;
var UWindowEditControl ShieldAmount;
var UWindowEditControl StartingAmmoAmount;
var UWindowEditControl PickupAmmoAmount;
var UWindowEditControl MaxAmmoAmount;

function Created()
{
   Super.Created();
   
   Label = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 20, 70, 1));
   Label.SetText("Shields Amount");
   Label = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 90, 20, 70, 1));
   Label.SetText("(max. 15)");
   ShieldAmount = UWindowEditControl(CreateControl(class'UWindowEditControl', 140, 15, 30, 1));
   ShieldAmount.SetNumericOnly(True);
   ShieldAmount.SetMaxLength(4);
   ShieldAmount.SetValue(string(class'InstaSniper.InstaSniperMut'.default.ShieldAmount));

   Label = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 50, 100, 1));
   Label.SetText("Default Ammo Amount");
   StartingAmmoAmount = UWindowEditControl(CreateControl(class'UWindowEditControl', 140, 45, 30, 1));
   StartingAmmoAmount.SetNumericOnly(True);
   StartingAmmoAmount.SetMaxLength(2);
   StartingAmmoAmount.SetValue(string(class'InstaSniper.InstaSniperMut'.default.StartingAmmoAmount));

   Label = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 80, 100, 1));
   Label.SetText("Pickup Ammo Amount");
   PickupAmmoAmount = UWindowEditControl(CreateControl(class'UWindowEditControl', 140, 75, 30, 1));
   PickupAmmoAmount.SetNumericOnly(True);
   PickupAmmoAmount.SetMaxLength(2);
   PickupAmmoAmount.SetValue(string(class'InstaSniper.InstaSniperMut'.default.PickupAmmoAmount));

   Label = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 110, 120, 1));
   Label.SetText("Maximum Ammo Amount");
   MaxAmmoAmount = UWindowEditControl(CreateControl(class'UWindowEditControl', 140, 105, 30, 1));
   MaxAmmoAmount.SetNumericOnly(True);
   MaxAmmoAmount.SetMaxLength(2);
   MaxAmmoAmount.SetValue(string(class'InstaSniper.InstaSniperMut'.default.MaxAmmoAmount));

   Label = UWindowLabelControl(CreateControl(class'UWindowLabelControl', 10, 140, 100, 1));
   Label.SetText("Hardcore Frags");
   bHardCoreFrags = UWindowCheckbox(CreateControl(class'UWindowCheckbox', 153, 137, 20, 1));
   bHardCoreFrags.bChecked = class'InstaSniper.InstaSniperMut'.default.bHardCoreFrags;
}

function Notify(UWindowDialogControl C, byte E)
{
   switch(E)
   {
   case DE_Change:
      switch(C)
      {
         case ShieldAmount:
            class'InstaSniper.InstaSniperMut'.default.ShieldAmount = int(ShieldAmount.GetValue());
            class'InstaSniper.InstaSniperMut'.static.StaticSaveConfig();
            if (int(ShieldAmount.GetValue()) > 15)
            ShieldAmount.SetValue("15");
            break;

         case StartingAmmoAmount:
            class'InstaSniper.InstaSniperMut'.default.StartingAmmoAmount = int(StartingAmmoAmount.GetValue());
            class'InstaSniper.InstaSniperMut'.static.StaticSaveConfig();
            break;

         case PickupAmmoAmount:
            class'InstaSniper.InstaSniperMut'.default.PickupAmmoAmount = int(PickupAmmoAmount.GetValue());
            class'InstaSniper.InstaSniperMut'.static.StaticSaveConfig();
            break;

         case MaxAmmoAmount:
            class'InstaSniper.InstaSniperMut'.default.MaxAmmoAmount = int(MaxAmmoAmount.GetValue());
            class'InstaSniper.InstaSniperMut'.static.StaticSaveConfig();
            break;

         case bHardCoreFrags:
            class'InstaSniper.InstaSniperMut'.default.bHardCoreFrags = bHardCoreFrags.bChecked;
            class'InstaSniper.InstaSniperMut'.static.StaticSaveConfig();
            break;
      }
   break;
   }

}

defaultproperties
{
}
