//=============================================================================
// ShootTarget - external controller for bots
//=============================================================================
class ShootTarget extends Decoration;

var bot RedCamper, BlueCamper;
var Medal M;

function PostBeginPlay()
{
	Super.PostBeginPlay();
	M = Spawn(class'Medal');

	SetTimer (1.0, true);
}

function Timer()
{
	local PlayerPawn P;
	local Bot B;
	local int Team;

	ForEach AllActors(class'Bot', B)
        {
                if ( B.Health <= 0 || B.PlayerReplicationInfo.HasFlag != None )
                        continue; 
                if (B.bCamping || B.bSniping) 
                {
                        if (B.PlayerReplicationInfo.Team == 1) 
                                BlueCamper = B;
                        else
                                RedCamper = B;
                }
                if (TSniperRifle(B.weapon) == None)
                        continue; 
                if (B.PlayerReplicationInfo.Team == 0)
                {
                        if (BlueCamper == None)
                                continue; 
                        if (B.Enemy != none && B.Enemy != BlueCamper)
                                continue; 
                        if ( !FastTrace(B.Location, BlueCamper.Location) )
                                continue; 
                        B.Enemy = BlueCamper;
                        B.gotostate('RangedAttack');
                        continue; 
                }
                if (RedCamper == None || B == RedCamper)
                        continue; 
                if (B.Enemy != none && B.Enemy != RedCamper)
                        continue; 
                if ( !FastTrace(B.Location, RedCamper.Location) )
                        continue; 
                B.Enemy = RedCamper;
                B.gotostate('RangedAttack');
        }

        ForEach AllActors(class'PlayerPawn', P)
        {
                if (P.Health <= 0 || P.weapon == None)
		{
			M.SetLocation (Vect(0,0,-30000));  
                        continue; 
		}
                if (owner == none)
                        SetOwner(P); 
		if (P == Owner)
                {
                       if(P.bIsCrouching)
                               M.SetLocation (P.Location + Vect(0,0,2)); 
                        else 
                               M.SetLocation (P.Location + Vect(0,0,29));  
                }
        }

        P = PlayerPawn(Owner); 
        if (P == None || P.PlayerReplicationInfo == None || P.Health <= 0)
                return; 
        Team = P.PlayerReplicationInfo.Team; 

        ForEach AllActors(class'Bot', B)
        {
                if (Level.Game.bTeamGame && B.PlayerReplicationInfo.Team == Team)
                        continue;
                if ( B.Health <= 0 || TSniperRifle(B.weapon) == None)
                        continue; 
                If (B.Enemy != None && B.Enemy != Owner)
                        continue;
                If (!FastTrace(M.Location, (B.Location + vect(0,0,24)) ) )
                        continue;

                B.Enemy = P;
		//BroadcastMessage("i am ready to shoot!", true);
                if (!FastTrace(P.Location, (B.Location + vect(0,0,24)) ) && !NeedToTurn(B) )
                {
                        B.FaceTarget = M; 
                        B.target = M; 
                        B.bShootSpecial = true; 
			//BroadcastMessage("I am shooting! Target ="@B.target, true);
                        B.FireWeapon(); 
                        //P.ClientMessage ("Fire To Head!!!");
                        continue;
                }
                if (B.PlayerReplicationInfo.HasFlag != None)
                        continue;
                if (!NeedToTurn(B))
                        B.gotostate('RangedAttack');
                else
                        B.gotostate('RangedAttack');
        }
}

function bool NeedToTurn(Bot B)
{
        Local Rotator NeedRot;
        Local int Real, Need, Result;

        NeedRot = Rotator(Owner.location - B.location);
        Need = Normalize(NeedRot).yaw+100000;
        Real = Normalize(B.Rotation).yaw+100000;
        Result = ABS(Need-Real);
         if (Result > 5200 && Result < 60000)
                return true;
        return false;
}

defaultproperties
{
    bStatic=False
    bHidden=True
    bStasis=False
}
