//=============================================================================
// TSniperRifle.
//=============================================================================
class TSniperRifle extends TournamentWeapon;

#exec TEXTURE IMPORT NAME=Xhair  FILE=Textures\Xhair.bmp GROUP="Sniper" MIPS=OFF
#exec TEXTURE IMPORT NAME=Cross  FILE=Textures\Cross.bmp GROUP="Sniper" MIPS=OFF
#exec AUDIO IMPORT FILE="Sounds\Shot.wav" 

var() texture CrossIcon[9];
var int NumFire;
var name FireAnims[5];
var vector OwnerLocation;
var float StillTime, StillStart;
var bool bZoom;

simulated function PostRender( canvas Canvas )
{
        local PlayerPawn P;
        local actor Other;
        local float S, m, Xlength, range, radpitch;
        local vector HitLocation, HitNormal, StartTrace, EndTrace, X, Y, Z;

	Super.PostRender(Canvas);
	P = PlayerPawn(Owner);
	if ( (P != None) && (P.DesiredFOV != P.DefaultFOV) ) 
	{
	        XLength=255.0;
		GetAxes(Pawn(owner).ViewRotation,X,Y,Z);
		if ((Pawn(Owner).ViewRotation.Pitch >= 0) && (Pawn(Owner).ViewRotation.Pitch <= 18000))
			radpitch = float(Pawn(Owner).ViewRotation.Pitch) / float(182) * (Pi/float(180));
		else
			radpitch = float(Pawn(Owner).ViewRotation.Pitch - 65535) / float(182) * (Pi/float(180));

		StartTrace = Owner.Location + Pawn(Owner).EyeHeight*Z*cos(radpitch);
	    	AdjustedAim = pawn(owner).AdjustAim(1000000, StartTrace, 2.75*AimError, False, False);
		EndTrace = StartTrace +(20000 * vector(AdjustedAim));
		Other = Pawn(Owner).TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
		range = Vsize(StartTrace-HitLocation)/48-0.25;

                bOwnsCrossHair = true;
		Canvas.Font = Font(DynamicLoadObject("LadderFonts.UTLadder20", class'Font'));
		Canvas.Style = ERenderStyle.STY_Translucent;
		Canvas.DrawColor = 15 * ChallengeHUD(P.myHUD).CrosshairColor;
		Canvas.SetPos(0.5 * Canvas.ClipX - 128, 0.5 * Canvas.ClipY - 128);
		Canvas.DrawIcon(Texture'Xhair', 1);
		S = P.DefaultFOV/P.DesiredFOV;
		Canvas.DrawColor.R = 255;
		Canvas.DrawColor.G = 255;
		Canvas.DrawColor.B = 255;
		Canvas.SetPos(0.5 * Canvas.ClipX + 192, 0.5 * Canvas.ClipY + 128);
		Canvas.DrawText("Zoom: "$int(S)$"."$int(10 * S - 10 * int(S)));
		Canvas.SetPos(0.5 * Canvas.ClipX + 192, 0.5 * Canvas.ClipY + 154);
		Canvas.DrawText( "Range: "$int(range)$"."$int(10 * range -10 * int(range)));
        }
        else
        {
                Canvas.DrawColor = 15 * ChallengeHUD(P.myHUD).CrosshairColor;
                Canvas.Style = ERenderStyle.STY_Translucent;
                Canvas.SetPos(0.5 * Canvas.ClipX - 32, 0.5 * Canvas.ClipY - 32);
                Canvas.DrawIcon(CrossIcon[ChallengeHUD(P.myHUD).CrossHair], 1);                       
        } 
                bOwnsCrossHair = true;
}

function float RateSelf( out int bUseAltMode )
{
	local float dist;

	if ( AmmoType.AmmoAmount <=0 )
		return -2;

	bUseAltMode = 0;
	if ( (Bot(Owner) != None) && Bot(Owner).bSniping )
		return AIRating + 1.15;
	if (  Pawn(Owner).Enemy != None )
	{
		dist = VSize(Pawn(Owner).Enemy.Location - Owner.Location);
		if ( dist > 1200 )
		{
			if ( dist > 2000 )
				return (AIRating + 0.75);
			return (AIRating + FMin(0.0001 * dist, 0.45)); 
		}
	}
	return AIRating;
}

// set which hand is holding weapon
function setHand(float Hand)
{
	Super.SetHand(Hand);
	if ( Hand == 1 )
		Mesh = mesh(DynamicLoadObject("Botpack.Rifle2mL", class'Mesh'));
	else
		Mesh = mesh'Rifle2m';
}

simulated function PlayFiring()
{
	local int r;

	PlayOwnedSound(FireSound, SLOT_None, Pawn(Owner).SoundDampening*3.0);
	PlayAnim(FireAnims[Rand(5)],0.5 + 0.5 * FireAdjust, 0.05);

	if ( (PlayerPawn(Owner) != None) 
		&& (PlayerPawn(Owner).DesiredFOV == PlayerPawn(Owner).DefaultFOV) )
		bMuzzleFlash++;
}


simulated function bool ClientAltFire( float Value )
{
	GotoState('Zooming');
	return true;
}

function AltFire( float Value )
{
	ClientAltFire(Value);
}

///////////////////////////////////////////////////////
state NormalFire
{
	function EndState()
	{
		Super.EndState();
		OldFlashCount = FlashCount;
	}
		
Begin:
	FlashCount++;
}

function Timer()
{
	local actor targ;
	local float bestAim, bestDist;
	local vector FireDir;
	local Pawn P;

	bestAim = 0.95;
	P = Pawn(Owner);
	if ( P == None )
	{
		GotoState('');
		return;
	}
	if ( VSize(P.Location - OwnerLocation) < 6 )
		StillTime += FMin(2.0, Level.TimeSeconds - StillStart);

	else
		StillTime = 0;
	StillStart = Level.TimeSeconds;
	OwnerLocation = P.Location;
	FireDir = vector(P.ViewRotation);
	targ = P.PickTarget(bestAim, bestDist, FireDir, Owner.Location);
	if ( Pawn(targ) != None )
	{
		SetTimer(1 + 4 * FRand(), false);
		bPointing = true;
		Pawn(targ).WarnTarget(P, 200, FireDir);
	}
	else 
	{
		SetTimer(0.4 + 1.6 * FRand(), false);
		if ( (P.bFire == 0) && (P.bAltFire == 0) )
			bPointing = false;
	}
}	

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local UT_Shellcase s;

	s = Spawn(class'UT_ShellCase',, '', Owner.Location + CalcDrawOffset() + 30 * X + (2.8 * FireOffset.Y+5.0) * Y - Z * 1);
	if ( s != None ) 
	{
		s.DrawScale = 2.0;
		s.Eject(((FRand()*0.3+0.4)*X + (FRand()*0.2+0.2)*Y + (FRand()*0.3+1.0) * Z)*160);              
	}
	if (Other == Level)
	{               
		Spawn(class'Explosion',,, HitLocation);
		Spawn(class'WallHit',,, HitLocation+HitNormal, Rotator(HitNormal));
	}
        else if ( (Other != self) && (Other != Owner) && (Other != None) ) 
	{
		if ( Other.bIsPawn )
			Other.PlaySound(Sound 'ChunkHit',, 4.0,,100);
		if ( Other.IsA('StationaryPawn'))
			Other.TakeDamage(1000, Pawn(Owner), HitLocation, 30000 * X, MyDamageType);
                else 
			Other.TakeDamage(100, Pawn(Owner), HitLocation, 30000 * X, MyDamageType);
        }
}

function Finish()
{
	if ( (Pawn(Owner).bFire!=0) && (FRand() < 0.6) )
		Timer();
	Super.Finish();
}

function TraceFire( float Accuracy )
{
        local vector AimDir;
        local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
        local actor Other;
        local Pawn PawnOwner;
        local PlayerPawn P;

        Local InstaTracer IT;
        Local float IT_Speed;

        PawnOwner = Pawn(Owner);
        Owner.MakeNoise(PawnOwner.SoundDampening);
        GetAxes(PawnOwner.ViewRotation,X,Y,Z);
        P = PlayerPawn(Owner);
        StartTrace = PawnOwner.Location + (PawnOwner.Eyeheight * vect(0,0,1));
        AdjustedAim = PawnOwner.AdjustAim(1000000, StartTrace, 2*AimError, False, False);
        X = vector(AdjustedAim);
        AimDir = vector(AdjustedAim);
        EndTrace = StartTrace + 20000 * X;
        Other = PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

        if (P != None && (P.DesiredFOV == P.DefaultFOV) && ABS(P.Handedness) == 1)
        {
                StartTrace = P.Location + CalcDrawOffset() + 96 * AimDir - Vect(0,0,1);
        }
        else 
                StartTrace = PawnOwner.Location + vect(0,0,0.7)*(PawnOwner.Eyeheight) + 96 * AimDir;

        if ( VSize(HitLocation - StartTrace) > 0 )
        {
                if (HitLocation == vect(0,0,0)) 
                        HitLocation = EndTrace;
                IT = Spawn(class'InstaTracer',,,StartTrace,rotator(HitLocation - StartTrace));
                If (IT != None)
                {
                        IT_Speed = IT.Speed/VSize(HitLocation - StartTrace);
                        IT.Velocity = (HitLocation - StartTrace)*IT_Speed;
                }
        }

        ProcessTraceHit(Other, HitLocation, HitNormal, X,Y,Z);

}

state Idle
{
	function Fire( float Value )
	{
		if ( AmmoType == None )
		{
			// ammocheck
		          GiveAmmo(Pawn(Owner));
		}
		if (AmmoType.UseAmmo(1))
		{
		        GotoState('NormalFire');
			bCanClientFire = true;
			bPointing=True;
			if ( Owner.IsA('Bot') )
			{
				// simulate bot using zoom
				if ( Bot(Owner).bSniping && (FRand() < 0.65) )
					AimError = AimError/FClamp(StillTime, 1.0, 8.0);
				else if ( VSize(Owner.Location - OwnerLocation) < 6 )
					AimError = AimError/FClamp(0.5 * StillTime, 1.0, 3.0);
				else
					StillTime = 0;
			}
			Pawn(Owner).PlayRecoil(FiringSpeed);
			TraceFire(0.0);
			AimError = Default.AimError;
			ClientFire(Value);
		}
	}


	function BeginState()
	{
		bPointing = false;
		SetTimer(0.4 + 1.6 * FRand(), false);
		Super.BeginState();
	}

	function EndState()
	{	
		SetTimer(0.0, false);
		Super.EndState();
	}
	
Begin:
	bPointing=False;
	if ( AmmoType.AmmoAmount<=0 ) 
	        Pawn(Owner).SwitchToBestWeapon();  //Goto Weapon that has Ammo
	if ( Pawn(Owner).bFire!=0 ) Fire(0.0);
	Disable('AnimEnd');
	PlayIdleAnim();
}

///////////////////////////////////////////////////////
state Zooming
{
	simulated function Tick(float DeltaTime)
	{
		if ( Pawn(Owner).bAltFire == 0 )
		{
			bZoom = false;
			SetTimer(0.0,False);
			GoToState('Idle');
		}
		else if ( bZoom )
		{
			if ( PlayerPawn(Owner).DesiredFOV > 3.0 )
			{
				PlayerPawn(Owner).DesiredFOV -= PlayerPawn(Owner).DesiredFOV * DeltaTime * 3.8;
			}

			if ( PlayerPawn(Owner).DesiredFOV <=3.0 )
			{
				PlayerPawn(Owner).DesiredFOV = 3.0;
				bZoom = false;
				SetTimer(0.0,False);
				GoToState('Idle');
			}
		}
	}

	simulated function BeginState()
	{
		if ( Owner.IsA('PlayerPawn') )
		{
			if ( PlayerPawn(Owner).DesiredFOV == PlayerPawn(Owner).DefaultFOV )
			{
				bZoom = true;
				SetTimer(0.2,True);
			}
			else if ( bZoom == false )
			{
				PlayerPawn(Owner).DesiredFOV = PlayerPawn(Owner).DefaultFOV;
				Pawn(Owner).bAltFire = 0;
			}
		}
		else
		{
			Pawn(Owner).bFire = 1;
			Pawn(Owner).bAltFire = 0;
			Global.Fire(0);
		}
	}
}

///////////////////////////////////////////////////////////
simulated function PlayIdleAnim()
{
	if ( Mesh != PickupViewMesh )
		PlayAnim('Still',1.0, 0.05);
}

state Pickup
{
        function Timer()
        {
                if ( RemoteRole != ROLE_SimulatedProxy )
                {
                        NetPriority = 1.4;
                        RemoteRole = ROLE_SimulatedProxy;
                        if ( bHeldItem )
                        {
                                if ( bTossedOut )
                                        SetTimer(15.0, false);
                                else
                                        SetTimer(25.0, false);
                        }
                        return;
                }

                if ( bHeldItem )
                {
                        if (  (FRand() < 0.1) || !PlayerCanSeeMe() )
                                Destroy();
                        else
                                SetTimer(0.5, true);
                }
        }
}

event float BotDesireability(Pawn Bot)
{
	If ( Bot.Enemy != None && VSize(Bot.Location - Bot.Enemy.Location) < 1024 ) 
		return -1; 
	return 1.0; 
}

function SetWeaponStay()
{
	bWeaponStay = false; // InstaGib Rifle never stays
}

defaultproperties
{
     CrossIcon(0)=Texture'Botpack.Icons.Chair1'
     CrossIcon(1)=Texture'Botpack.Icons.Chair2'
     CrossIcon(2)=Texture'Botpack.Icons.CHair3'
     CrossIcon(3)=Texture'Botpack.Icons.CHair4'
     CrossIcon(4)=Texture'Botpack.Icons.CHair5'
     CrossIcon(5)=Texture'Botpack.Icons.CHair6'
     CrossIcon(6)=Texture'Botpack.Icons.CHair7'
     CrossIcon(7)=Texture'InstaSniper.Sniper.Cross'
     CrossIcon(8)=Texture'Botpack.Icons.CHair9'
     FireAnims(0)=Fire
     FireAnims(1)=Fire2
     FireAnims(2)=Fire3
     FireAnims(3)=Fire4
     FireAnims(4)=Fire5
     WeaponDescription="Classification: Long Range Ballistic"
     AmmoName=Class'InstaSniper.InstAmmo'
     PickupAmmoCount=2
     bInstantHit=True
     bAltInstantHit=True
     FiringSpeed=1.800000
     FireOffset=(Y=-5.000000,Z=-2.000000)
     MyDamageType=shot
     shakemag=0.000000
     shaketime=0.000000
     shakevert=0.000000
     AIRating=0.750000
     RefireRate=0.600000
     AltRefireRate=0.300000
     FireSound=Sound'InstaSniper.shot'
     SelectSound=Sound'UnrealI.Rifle.RiflePickup'
     NameColor=(R=0,G=0)
     bDrawMuzzleFlash=True
     MuzzleScale=1.000000
     FlashY=0.110000
     FlashO=0.014000
     FlashC=0.031000
     FlashLength=0.013000
     FlashS=256
     MFTexture=Texture'Botpack.Rifle.MuzzleFlash2'
     AutoSwitchPriority=2
     InventoryGroup=2
     PickupMessage="You got an InstaGib Rifle."
     ItemName="InstaGib Rifle"
     PlayerViewOffset=(X=5.000000,Y=-1.600000,Z=-1.700000)
     PlayerViewMesh=LodMesh'Botpack.Rifle2m'
     PlayerViewScale=2.000000
     BobDamping=0.975000
     PickupViewMesh=LodMesh'Botpack.RiflePick'
     ThirdPersonMesh=LodMesh'Botpack.RifleHand'
     StatusIcon=Texture'Botpack.Icons.UseRifle'
     bMuzzleFlashParticles=True
     MuzzleFlashStyle=STY_Translucent
     MuzzleFlashMesh=LodMesh'Botpack.muzzsr3'
     MuzzleFlashScale=0.100000
     MuzzleFlashTexture=Texture'Botpack.Skins.Muzzy3'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Icon=Texture'Botpack.Icons.UseRifle'
     Rotation=(Roll=-1536)
     Mesh=LodMesh'Botpack.RiflePick'
     bNoSmooth=False
     CollisionRadius=32.000000
     CollisionHeight=8.000000
}
