class ISPP_Ladder extends UTLadder abstract;

function EvaluateMatch(optional bool bTrophyVictory)
{
	local string SaveString;
	local int Team, i;

	// Save the game.
	if (LadderObj != None)
	{
		SaveString = string(LadderObj.TournamentDifficulty);
		if (!class'UTLadderStub'.Static.GetStubClass().Static.IsDemo())
		{
			for (i=0; i<class'ISP_Ladder'.Default.NumTeams; i++)
			{
				if (class'ISP_Ladder'.Default.LadderTeams[i] == LadderObj.Team)
					Team = i;
			}
		} else {
			if (class'ISP_Ladder'.Default.LadderTeams[class'ISP_Ladder'.Default.NumTeams] == LadderObj.Team)
				Team = class'ISP_Ladder'.Default.NumTeams;
			else
				Team = class'ISP_Ladder'.Default.NumTeams+1;
		}
		SaveString = SaveString$"\\"$Team;
		SaveString = SaveString$"\\"$LadderObj.DMRank;
		SaveString = SaveString$"\\"$LadderObj.DMPosition;
		SaveString = SaveString$"\\"$LadderObj.DOMRank;
		SaveString = SaveString$"\\"$LadderObj.DOMPosition;
		SaveString = SaveString$"\\"$LadderObj.CTFRank;
		SaveString = SaveString$"\\"$LadderObj.CTFPosition;
		SaveString = SaveString$"\\"$LadderObj.ASRank;
		SaveString = SaveString$"\\"$LadderObj.ASPosition;
		SaveString = SaveString$"\\"$LadderObj.ChalRank;
		SaveString = SaveString$"\\"$LadderObj.ChalPosition;
		SaveString = SaveString$"\\"$LadderObj.Sex;
		SaveString = SaveString$"\\"$LadderObj.Face;
		SaveString = SaveString$"\\"$GetPlayerOwner().PlayerReplicationInfo.PlayerName;
		class'ISP_SlotWindow'.Default.Saves[LadderObj.Slot] = SaveString;
		class'ISP_SlotWindow'.Static.StaticSaveConfig();

		if (LadderObj.PendingPosition > 7)
		{
			SelectedMatch = LadderObj.PendingPosition;
			BaseMatch = LadderObj.PendingPosition - 7;
			ArrowPos = LadderObj.PendingPosition - 1;
			PendingPos = LadderObj.PendingPosition;
		}
		LadderObj.PendingPosition = 0;
		if (bTrophyVictory)
			bTrophyTravelPending = True;

		SelectedMatch = LadderPos;
		SetMapShot(LadderPos);
		FillInfoArea(LadderPos);
	}
}


function StartMap(string StartMap, int Rung, string GameType)
{
        local Class<GameInfo> GameClass;

        GameClass = Class<GameInfo>(DynamicLoadObject(GameType, Class'Class'));
        GameClass.Static.ResetGame();

        StartMap = StartMap
                                $"?Game="$GameType
                                $"?Mutator=InstaSniper.SingleMut"
                                $"?Tournament="$Rung
                                $"?Name="$GetPlayerOwner().PlayerReplicationInfo.PlayerName
                                $"?Team=0";

        Root.SetMousePos((Root.WinWidth*Root.GUIScale)/2, (Root.WinHeight*Root.GUIScale)/2);
        Root.Console.CloseUWindow();
        GetPlayerOwner().ClientTravel(StartMap, TRAVEL_Absolute, True);
}

function BackPressed()
{
        Root.CreateWindow(class'ISP_ManagerWindow', 100, 100, 200, 200, Root, True);
        Close();
}

defaultproperties
{
}
