//=============================================================================
// ISP_GameMenu
//=============================================================================

class ISP_GameMenu expands Uwindowpulldownmenu;

var UWindowPulldownMenuItem NewGame, LoadGame, Botmatch, Quit, ReturnToGame;

var localized string SaveName;
var localized string QuitText;
var UWindowMessageBox ConfirmQuit;

function Created()
{
        Super.Created();

        // Add menu items.
        NewGame = AddMenuItem(class'utmenu.utgamemenu'.default.NewGameName, None);
        LoadGame = AddMenuItem(class'utmenu.utgamemenu'.default.LoadGameName, None);
        AddMenuItem("-", None);
        Botmatch = AddMenuItem(class'utmenu.utgamemenu'.default.BotmatchName, None);
        AddMenuItem("-", None);

        ReturnToGame = AddMenuItem(class'utmenu.utgamemenu'.default.ReturnToGameName, None);
        AddMenuItem("-", None);
        Quit = AddMenuItem(class'utmenu.utgamemenu'.default.QuitName, None);
}

function ShowWindow()
{
        Super.ShowWindow();
        ReturnToGame.bDisabled = GetLevel().Game != None && GetLevel().Game.IsA('UTIntro');
}

function ExecuteItem(UWindowPulldownMenuItem I)
{
        switch(I)
        {
        case NewGame:
                InitConsole();
                GetPlayerOwner().ClientTravel( "UT-Logo-Map.unr?Game=Botpack.LadderNewGame", TRAVEL_Absolute, True );
                break;
        case LoadGame:
                InitConsole();
                GetPlayerOwner().ClientTravel( "UT-Logo-Map.unr?Game=Botpack.LadderLoadGame", TRAVEL_Absolute, True );
                break;
        case Botmatch:
                Root.CreateWindow(class'utmenu.UTBotmatchWindow', 100, 100, 200, 200, Self, True);
                break;
        case Quit:
                ConfirmQuit = MessageBox(class'utmenu.utgamemenu'.default.QuitTitle, QuitText, MB_YesNo, MR_No, MR_Yes);
                break;
        case ReturnToGame:
                Root.Console.CloseUWindow();
                break;
        }

        Super.ExecuteItem(I);
}

function InitConsole()
{
        UTConsole(GetPlayerOwner().Player.Console).ManagerWindowClass="InstaSniperSP.ISP_ManagerWindow";
        UTConsole(GetPlayerOwner().Player.Console).UTLadderDMClass="InstaSniperSP.ISP_LadderDM";
        UTConsole(GetPlayerOwner().Player.Console).UTLadderCTFClass="InstaSniperSP.ISP_LadderCTF";
        UTConsole(GetPlayerOwner().Player.Console).UTLadderDOMClass="InstaSniperSP.ISP_LadderDOM";
        UTConsole(GetPlayerOwner().Player.Console).UTLadderASClass="InstaSniperSP.ISP_LadderAS";
        UTConsole(GetPlayerOwner().Player.Console).UTLadderChalClass="InstaSniperSP.ISP_LadderChal";
        UTConsole(GetPlayerOwner().Player.Console).InterimObjectType="InstaSniperSP.ISP_NewGameInterimObject";
        UTConsole(GetPlayerOwner().Player.Console).SlotWindowType="InstaSniperSP.ISP_SlotWindow";
}


function MessageBoxDone(UWindowMessageBox W, MessageBoxResult Result)
{
        if(W == ConfirmQuit &&Result == MR_Yes)
                Root.QuitGame();
}

function Select(UWindowPulldownMenuItem I)
{
        switch(I)
        {
        case NewGame:
                UMenuMenuBar(GetMenuBar()).SetHelp(class'utmenu.utgamemenu'.default.NewGameHelp);
                return;
        case LoadGame:
                UMenuMenuBar(GetMenuBar()).SetHelp(class'utmenu.utgamemenu'.default.LoadGameHelp);
                return;
        case Botmatch:
                UMenuMenuBar(GetMenuBar()).SetHelp(class'utmenu.utgamemenu'.default.BotmatchHelp);
                break;
        case Quit:
                UMenuMenuBar(GetMenuBar()).SetHelp(class'umenu.umenugamemenu'.default.QuitHelp);
                break;
        case returntogame:
                UMenuMenuBar(GetMenuBar()).SetHelp(class'utmenu.utgamemenu'.default.returntogameHelp);
                break;

        }
        Super.Select(I);
}

defaultproperties
{
     QuitText="Are you sure you want to Quit InstaSniper Tournament?"
}
