class ISP_NewCharacterWindow extends NewCharacterWindow;

function Created()
{
	local string MeshName, SkinDesc, Temp;
	local int i;
	local int W, H;
	local float XWidth, YHeight, XMod, YMod, XPos, YPos;
	local color TextColor;

	Super.Created();

	if (class'UTLadderStub'.Static.GetStubClass().Static.IsDemo())
		PreferredTeam = class'ISP_Ladder'.Default.NumTeams;

	MaleClass = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.MaleClass;
	MaleSkin = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.MaleSkin;

	FemaleClass = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.FemaleClass;
	FemaleSkin = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.FemaleSkin;

	if ((PreferredTeam == class'ISP_Ladder'.Default.NumTeams) && (!class'UTLadderStub'.Static.GetStubClass().Static.IsDemo()))
		PreferredTeam = 0;
	TeamButton.Text = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.TeamName;
	LadderObj.Team = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam];
}

function Paint(Canvas C, float X, float Y)
{
	local int XOffset, YOffset;
	local int W, H;
	local float XWidth, YHeight, XMod, YMod, XPos, YPos;

	Super.Paint(C, X, Y);

	if (Root.WinWidth > 500)
	{
		DrawStretchedTexture(C, XOffset + (0 * W), YOffset + (0 * H), (W+1)/2, (H+1)/2, texture'TeamPlate');
		DrawStretchedTexture(C, XOffset + (0 * W) + (65.0/1024*XMod), YOffset + (0 * H) + (61.0/768*YMod), (58.0/1024*XMod), (57.0/768*YMod), class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.TeamSymbol);
	}
}

function TeamPressed()
{
	local string MeshName;

	Super.TeamPressed();

	if (!class'UTLadderStub'.Static.GetStubClass().Static.IsDemo())
	{
		PreferredTeam++;
		if (PreferredTeam == class'ISP_Ladder'.Default.NumTeams)
			PreferredTeam = 0;
	}
	TeamButton.Text = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.TeamName;
	LadderObj.Team = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam];

	// Update mesh
	MaleClass = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.MaleClass;
	MaleSkin = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.MaleSkin;
	FemaleClass = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.FemaleClass;
	FemaleSkin = class'ISP_Ladder'.Default.LadderTeams[PreferredTeam].Default.FemaleSkin;
}

function NextPressed()
{
	local int i;
	local ISP_ManagerWindow ISP_ManagerWindow;

	if (LadderObj.Sex ~= "F")
	{
		SexButton.Text = MaleText;
	} else {
		SexButton.Text = FemaleText;
	}
	SexPressed();

	// Go to the ladder selection screen.
	LadderObj.DMRank = 0;
	LadderObj.DMPosition = -1;
	LadderObj.CTFRank = 0;
	LadderObj.CTFPosition = -1;
	LadderObj.DOMRank = 0;
	LadderObj.DOMPosition = -1;
	LadderObj.ASRank = 0;
	LadderObj.ASPosition = -1;
	LadderObj.ChalRank = 0;
	LadderObj.ChalPosition = 0;

        LadderObj = None;
        ISP_ManagerWindow = ISP_ManagerWindow(Root.CreateWindow(class'ISP_ManagerWindow', 100, 100, 200, 200, Root, True));
        Super(NotifyWindow).Close();
}

defaultproperties
{
     PreferredSkill=4
}
