class ISP_ObjectiveBrowser extends ObjectiveBrowser;

function StartMap(string StartMap, int Rung, string GameType)
{
	local Class<GameInfo> GameClass;

	GameClass = Class<GameInfo>(DynamicLoadObject(GameType, Class'Class'));
	GameClass.Static.ResetGame();

	StartMap = StartMap
				$"?Game="$GameType
				$"?Mutator=InstaSniper.SingleMut"
				$"?Tournament="$Rung
				$"?Name="$GetPlayerOwner().PlayerReplicationInfo.PlayerName
				$"?Team=0";


	Root.SetMousePos((Root.WinWidth*Root.GUIScale)/2, (Root.WinHeight*Root.GUIScale)/2);
	Root.Console.CloseUWindow();
	GetPlayerOwner().ClientTravel(StartMap, TRAVEL_Absolute, True);
}

function NextPressed()
{
	local ISP_TeamBrowser TB;

	HideWindow();
	TB = ISP_TeamBrowser(Root.CreateWindow(class'ISP_TeamBrowser', 100, 100, 200, 200, Root, True));
	TB.LadderWindow = LadderWindow;
	TB.ObjectiveWindow = Self;
	TB.LadderWindow = LadderWindow;
	TB.Ladder = Ladder;
	TB.Match = Match;
	TB.GameType = GameType;
	TB.Initialize();
}

function NameSelected(int i)
{
	local AssaultInfo AI;

	SelectedO = i;
	SetMapShot(class'SP_LadderAS'.Static.GetObjectiveShot(Match, i, AI));
	AddObjDesc();
}

function AddObjDesc()
{
	local AssaultInfo AI;

	ObjDescArea.Clear();
	ObjDescArea.AddText(OrdersTransmissionText);
	ObjDescArea.AddText("---");
	ObjDescArea.AddText(class'SP_LadderAS'.Static.GetObjectiveString(Match, SelectedO, AI));
}

defaultproperties
{
}
